<?php
/*  Copyright 2004 Patrick R. Michaud (pmichaud@pobox.com)
    This file is part of PmWiki; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published
    by the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.  See pmwiki.php for full details.

    This script restores the layout used as of PmWiki version 0.5.27,
    for those who need to maintain compatibility with previous layouts.
    Note that this script is still beta--there may be some definitions
    and other features that need to be duplicated from version 0.5.27
    before this script is complete.

    To use this script, simply add the line
	include_once("scripts/layout-0.5.php");
    at the beginning of the local.php file.
*/

$BodyWidth = 600;
$BodyLeft = 20;
$HTTPHeaders=array(
  "Expires: Tue, 01 Jan 2002 00:00:00 GMT",
  "Last-Modified: ".gmstrftime('%a, %d %b %Y %H:%M:%S GMT'),
  "Cache-Control: no-store, no-cache, must-revalidate, post-check=0, pre-check=0",
  "Pragma: no-cache",
  "Content-Type: text/html; charset=iso-8859-1;");
$HTMLDoctypeFmt = 
  "<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.01 Transitional//EN\" 
    \"http://www.w3.org/TR/html40/loose.dtd\">
  <html><head>";
$HTMLTitleFmt = "<title>\$WikiTitle - \$HTMLTitle</title>";
$HTMLHeaderFmt = "<style type='text/css'>
  HR { text-align:left; }
  .wikiheader { font-size:32px; font-weight:bold; }
  .wikiops, .wikifooter { font-size:13px; }
  .wikibody { margin-left:\$BodyLeftpx; width:\$BodyWidthpx; }
  .revdate { font-family:verdana,sans-serif; font-size:11px; }
  .revtype { font-family:verdana,sans-serif; font-size:11px; font-weight:bold; }
  .revadd { background:#99ff99; color:black; }
  .revdel { background:#ffff99; color:black; }
</style>";
$HTMLBodyFmt = "</head><body bgcolor='#ffffff'><div class='wikibody'>";
$HTMLStartFmt = array('headers:',&$HTMLDoctypeFmt,&$HTMLTitleFmt,
  &$HTMLHeaderFmt,&$HTMLBodyFmt);
$HTMLEndFmt = "</div></body></html>";
$PageHeaderFmt = "
  <table width='\$BodyWidth' cellpadding='0' cellspacing='0' border='0'>
  <tr><td valign='bottom' align='left' width='10%'>\$WikiImg&nbsp;&nbsp;</td>
    <td valign='bottom' align='left'><a href='\$ScriptUrl/\$Group'>\$Group</a> /<br />
      <span class='wikiheader'><a href='\$PageUrl?action=search&amp;text=\$Title_'>\$Title</a></span></td>
    <td valign='bottom' align='right' class='wikiops'>
      <a href='\$ScriptUrl/$[Main/SearchWiki]'>$[SearchWiki]</a><br />
      <a href='\$ScriptUrl/$[\$Group/RecentChanges]'>\$Group.$[RecentChanges]</a><br />
      <a href='\$PageUrl?action=edit'>$[Edit Page]</a><br />
      <a href='\$PageUrl?action=diff'>$[Page Revisions]</a></td>
   </tr></table><hr /><p />";
$PageTitleFmt = '';
$PageRedirectFmt = "<i>($[redirected from] <a href='\$PageUrl?action=edit'>\$PageName</a>)</i><p />\n";
$PageFooterFmt = "<hr /><small>
  <a href='\$PageUrl?action=edit'>$[Edit Page]</a> - 
  <a href='\$PageUrl?action=diff'>$[Page Revisions]</a> -
  <a href='\$ScriptUrl/$[PmWiki/WikiHelp]'>$[WikiHelp]</a> -
  <a href='\$ScriptUrl/$[Main/SearchWiki]'>$[SearchWiki]</a> -
  <a href='\$ScriptUrl/$[\$Group/RecentChanges]'>$[RecentChanges]</a><br />
  $[Page last modified on \$LastModified]</small>";
$PageEditFmt = "<a id='top' name='top'></a><h1>Editing \$PageName</h1>
  <form action='\$PageUrl' method='post'>
  <input type='hidden' name='pagename' value='\$PageName' />
  <input type='hidden' name='action' value='edit' />
  <textarea name='text' rows='25' cols='80'
    onkeydown='if (event.keyCode == 27) event.returnValue=false;'
    >\$Text</textarea><br />
  <input type='submit' name='post' value=' $[Save] ' />
  <input type='submit' name='preview' value=' $[Preview] ' />
  <input type='reset' value=' $[Reset] ' />
  </form>";
$PagePreviewFmt = array(
  "function:ProcessTextDirectives",
  "<h2>Preview \$PageName</h2><b>Page is unsaved</b><hr /><p />",
  "function:PrintText",
  "<hr /><b>End of preview -- remember to save</b>
   <br /><a href='#top'>$[Top]</a>");
$PageDiffFmt = "<h1><a href='\$PageUrl'>\$PageName</a> $[Revisions]</h1>";
$PageDiffFootFmt = "<p /><hr />$[Back to] <a href='\$PageUrl'>\$PageName</a>";
$PageAttrFmt = "<h1>$[\$PageName Attributes]</h1>
    <p>Enter new attributes for this page below.  Leaving a field blank
    will leave the attribute unchanged.  To clear an attribute, enter 
    'clear'.</p>";
$HandleBrowseFmt = array(&$HTMLStartFmt,&$PageHeaderFmt,&$PageTitleFmt,
  &$PageRedirectFmt,"function:PrintText",&$PageFooterFmt,&$HTMLEndFmt);
$HandleEditFmt = array(&$HTMLStartFmt,&$PageEditFmt,
  "wiki:$[PmWiki.EditQuickReference]",&$PagePreviewFmt,&$HTMLEndFmt);
$HandleDiffFmt = array(&$HTMLStartFmt,&$PageDiffFmt,'function:PrintDiff',
  &$PageDiffFootFmt,&$HTMLEndFmt);
?>
