<?php

/*  Copyright 2004 Patrick R. Michaud (pmichaud@pobox.com)
    This file is part of PmWiki; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published
    by the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.  See pmwiki.php for full details.

    This script defines routines for displaying page revisions.  It
    is included by default from the stdconfig.php script.
*/

SDV($PageDiffFmt,"<h1>\$PageName $[Revisions]</h1>");
SDV($HandleDiffFmt,array(&$HTMLStartFmt,&$PageHeaderFmt,&$PageTitleFmt,
  "<div id='wikitext'>",&$PageDiffFmt,'function:PrintDiff',"</div>",
  &$PageFooterFmt,&$HTMLEndFmt));
SDV($DiffStartFmt,"<div class='diffbox'><div class='difftime'>\$DiffTime</div>");
SDV($DiffDelFmt['a'],"<div class='difftype'>\$[Deleted] \$DiffLines:</div>
  <div class='diffdel'>");
SDV($DiffDelFmt['c'],"<div class='difftype'>\$[Changed] \$DiffLines \$[from]:</div>
  <div class='diffdel'>");
SDV($DiffAddFmt['d'],"<div class='difftype'>\$[Added] \$DiffLines:</div>
  <div class='diffadd'>");
SDV($DiffAddFmt['c'],"</div><div class='difftype'>$[to]:</div>
  <div class='diffadd'>");
SDV($DiffEndDelAddFmt,"</div>");
SDV($DiffEndFmt,"</div></div>");
SDV($DiffRestoreFmt,"<div class='diffrestore'><a href='\$PageUrl?action=edit&amp;restore=\$DiffGmt&amp;preview=y'>$[Restore]</a></div>");

$HandleActions['diff']='HandleDiff';

function PrintDiff($pagename) {
  global $DiffGmt,$DiffTime,$TimeFmt,$GCount;
  global $DiffStartFmt,$DiffEndFmt,$DiffAddFmt,$DiffDelFmt,
    $DiffEndDelAddFmt,$DiffRestoreFmt,$SysPatchCmd;
  $page = ReadPage($pagename);
  if (!$page) return;
  Lock(0); 
  krsort($page); reset($page);
  foreach($page as $k=>$v) {
    if (!preg_match("/^diff:(\d+):(\d+)/",$k,$match)) continue;
    $DiffGmt = $match[1];
    $DiffTime = strftime($TimeFmt,$DiffGmt); $GCount=0;
    echo FmtPageName($DiffStartFmt,$pagename);
    $difflines = explode("\n",$v."\n");
    $in=array(); $out=array(); $dtype='';
    foreach($difflines as $d) {
      if ($d>'') {
        if ($d[0]=='-' || $d[0]=='\\') continue;
        if ($d[0]=='<') { $out[]=substr($d,2); continue; }
        if ($d[0]=='>') { $in[]=substr($d,2); continue; }
      }
      if (preg_match("/^(\\d+)(,(\\d+))?([adc])\\d/",$dtype,$match)) {
        $clines = ($match[3]>'') ? '$[lines] '.$match[1].'-'.$match[3] :
          '$[line] '.$match[1];
        if ($match[4]=='a' || $match[4]=='c') {
          $txt = str_replace('$DiffLines',$clines,$DiffDelFmt[$match[4]]);
          echo FmtPageName($txt,$pagename);
          PrintText($pagename,join("\n",$in));
        }
        if ($match[4]=='d' || $match[4]=='c') {
          $txt = str_replace('$DiffLines',$clines,$DiffAddFmt[$match[4]]);
          echo FmtPageName($txt,$pagename);
          PrintText($pagename,join("\n",$out));
        }
        echo FmtPageName($DiffEndDelAddFmt,$pagename);
      }
      $in=array(); $out=array(); $dtype=$d;
    }
    echo FmtPageName($DiffEndFmt,$pagename);
    if ($SysPatchCmd) echo FmtPageName($DiffRestoreFmt,$pagename);
  }
}

function HandleDiff($pagename) {
  global $HandleDiffFmt,$HTMLTitle;
  $page = RetrieveAuthPage($pagename,"read");
  if (!$page) { Abort("?cannot diff $pagename"); }
  Lock(0);
  $HTMLTitle = "$pagename Revisions";
  PrintFmt($pagename,$HandleDiffFmt);
}
